import Head from 'next/head'
import 'bootstrap/dist/css/bootstrap.min.css';
import Header from '../comp/header';
import Main from '../comp/main';
import { useState, useEffect } from "react";
import { useRouter } from 'next/router';
import { userService } from '../helper/user.service';

export default function Home() {

  const router = useRouter();
  const [user, setUser] = useState(null);
  const [authorized, setAuthorized] = useState(false);

  useEffect(() => {
    if (router.asPath === "/") {
      window.onpopstate = () => {
        history.go(1);
      };
    }
    // on initial load - run auth check
    authCheck(router.asPath);

    // on route change start - hide page content by setting authorized to false
    const hideContent = () => setAuthorized(false);
    router.events.on("routeChangeStart", hideContent);

    // on route change complete - run auth check
    router.events.on("routeChangeComplete", authCheck);

    // unsubscribe from events in useEffect return function
    return () => {
      router.events.off("routeChangeStart", hideContent);
      router.events.off("routeChangeComplete", authCheck);
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);

  function authCheck(url) {
    // redirect to login page if accessing a private page and not logged in
    setUser(userService.userValue);
    const publicPaths = ["/"];
    const path = url.split("?")[0];
    if (!userService.userValue && !publicPaths.includes(path)) {
      setAuthorized(false);
      router.push({
        pathname: "/",
        query: { returnUrl: router.asPath },
      });
    } else {
      setAuthorized(true);
    }
  }


  return (
    <div>
      <Head>
        <title>Udacity</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/logo.svg" height={100}/>
      </Head>

      <Header />
      
      <Main />

    </div>
  )
}
